{-# LANGUAGE FlexibleContexts, TemplateHaskell, TypeFamilies, OverloadedStrings #-}
module Structure where

import GHC.Generics
import Generics.BiGUL
import Generics.BiGUL.Interpreter
import Generics.BiGUL.TH
import Generics.BiGUL.Lib
import Data.List
import Control.Monad.Except
import Data.Maybe
import qualified Data.Map as Map
import Data.List
-- General datatypes for relational data

type Object = [KeyValuePair]
data Value = Obj Object | Str String | Arro [Object] | Arrs [String]
            deriving(Show)

type Key = String
type KeyValuePair = (Key, Value)

deriveBiGULGeneric ''Value


getvaluestring :: Value->String
getvaluestring v = case v of 
                   Obj tmp -> ""
                   Str tmp -> tmp
                   Arro tmp -> ""
                   Arrs tmp -> ""

getvalueobject :: Value->Object
getvalueobject v = case v of 
                   Obj tmp -> tmp
                   Str tmp -> []
                   Arro tmp -> []
                   Arrs tmp -> []

getvaluearraystring :: Value->[String]
getvaluearraystring v = case v of 
                   Obj tmp -> []
                   Str tmp -> []
                   Arro tmp -> []
                   Arrs tmp -> tmp

getvaluearrayobject :: Value->[Object]
getvaluearrayobject v = case v of 
                   Obj tmp -> []
                   Str tmp -> []
                   Arro tmp -> tmp
                   Arrs tmp -> []

valuetype :: Value -> Int
valuetype v = case v of
              Obj tmp -> 1
              Str tmp -> 2
              Arrs tmp -> 3
              Arro tmp -> 4
             


